/**************************************************************** 
 * Description: ACWing 1527  二叉树
 1、二叉搜索树的中序遍历是一个从小到大有序数列
 2、通过前序+中序就可以构建出原始的树来。
 3、二叉搜索树的镜像，其中某结点大于其右侧结点，小于左则结点。中序是递减
 * Author: Alex Li
 * Date: 2024-01-29 06:42:39
 * LastEditTime: 2024-08-08 12:02:11
****************************************************************/
#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>

using namespace std;

const int N = 1010;

int n;
// 前序遍历 中序遍历
int preorder[N], inorder[N];
// 后序遍历      后序遍历存值用cnt
int postorder[N], cnt;
// 重建搜索二叉树 中序遍历左右边界 前序遍历左右边界 有无镜像
bool build(int il, int ir, int pl, int pr, int type){
    if (il > ir) return true; // 当前区间没有元素 一定重建成功
    // 根结点 前序遍历的第一个结点
    int root = preorder[pl];
    int k;
    if (type == 0) {//原树 无镜像 从左向右找
    
        for (k = il; k <= ir; k ++ )
            if (inorder[k] == root)
                break;
        if (k > ir) return false;
    }
    else {//镜像 从右向左找
    
        for (k = ir; k >= il; k -- )
            if (inorder[k] == root)break;
        if (k < il) return false;
    }

    bool res = true;
    // 后序遍历 先遍历两个子树 再遍历两个根结点
    if (!build(il, k - 1, pl + 1, pl + 1 + (k - 1 - il), type)) res = false;// 左子树重建不成功
    if (!build(k + 1, ir, pl + 1 + (k - 1 - il) + 1, pr, type)) res = false;// 右子树重建不成功
    // 将根结点遍历
    postorder[cnt ++ ] = root;
    return res;
}

int main(){
    cin >> n;
    for (int i = 0; i < n; i ++ ){
        cin >> preorder[i];
        inorder[i] = preorder[i];
    }
    // 前序遍历排序得到中序遍历
    sort(inorder, inorder + n);
    // 是原二叉搜索树的前序遍历 type == 0
    if (build(0, n - 1, 0, n - 1, 0)){
        puts("YES");
        // 输出后序遍历
        cout << postorder[0];
        for (int i = 1; i < n; i ++ ) cout << ' ' << postorder[i];
        cout << endl;
    }
    else // 原二叉搜索树没有重建成功
    {
        // 翻转得到镜像 
        reverse(inorder, inorder + n);
        cnt = 0;
        // 判断根据镜像能否重建二叉搜索树 type == 1
        if (build(0, n - 1, 0, n - 1, 1)){
            puts("YES");
            cout << postorder[0];
            for (int i = 1; i < n; i ++ ) cout << ' ' << postorder[i];
            cout << endl;
        }
        // 重建不成功 其不是二叉搜索树或其镜像进行前序遍历的结果
        else puts("NO");
    }

    return 0;
}
